// Setup the icons, about dialog stuff and flags to be nice.
view.caption = "";
contentArea.contentFlags = gddContentFlagNone;
plugin.onShowOptionsDlg = ShowOptionsDlg; // handler for options dialog

SetDefaultOptions();

myTimer = setInterval(OnTimer, 1000 * 60);
OnTimer();    // update with first set of items

var teamsData;
var fullTeamNames;
var nbActiveSearches;
var bFoundValidSite;
var scoresUrl;
var iDayDiff;
var toAddLines;
var validUrl;
var invalidTeam;

function onUnload()
{
  utils.clearInterval(myTimer);
}

function HockeyTeam(city, team, abrv)
{
	this.city = city;
	this.team = team;
	this.abrv = abrv;
}

function BuildTeamsData()
{
  // CITY|TEAM|ABRV
  var strTeams = new Array(
                "Anaheim|Ducks|ANA",
                "Atlanta|Thrashers|ATL",
                "Boston|Bruins|BOS",
                "Buffalo|Sabres|BUF",
                "Calgary|Flames|CGY",
                "Carolina|Hurricanes|CAR",
                "Chicago|Blackhawks|CHI",
                "Colorado|Avalanche|COL",
                "Columbus|Blue Jackets|CBJ",
                "Dallas|Stars|DAL",
                "Detroit|Red Wings|DET",
                "Edmonton|Oilers|EDM",
                "Florida|Panthers|FLA",
                "Los Angeles|Kings|L.A",
                "Minnesota|Wild|MIN",
                "Montreal|Canadiens|MTL",
                "Nashville|Predators|NSH",
                "New Jersey|Devils|N.J",
                "New York|Islanders|NYI",
                "New York|Rangers|NYR",
                "Ottawa|Senators|OTT",
                "Philadelphia|Flyers|PHI",
                "Phoenix|Coyotes|PHX",
                "Pittsburgh|Penguins|PIT",
                "San Jose|Sharks|S.J",
                "St. Louis|Blues|STL",
                "Tampa Bay|Lightning|T.B",
                "Toronto|Maple Leafs|TOR",
                "Vancouver|Canucks|VAN",
                "Washington|Capitals|WSH");

	var tmpArray;
  teamsData = new Array(30);
  fullTeamNames = new Array(30);

	var i;
  for (i = 0; i < 30; ++i)
  {
  	tmpArray = strTeams[i].split("|");
    teamsData[i] = new HockeyTeam(tmpArray[0], tmpArray[1], tmpArray[2]);
    fullTeamNames[i] = teamsData[i].city + " " + teamsData[i].team;
  }

  invalidTeam = new HockeyTeam("Invalid", "Invalid", "N/A");
}

function GetTeamFromFullName(fullName)
{
	var i, j;
  for (i = 0; i < 30; ++i)
  {
    if ( fullName.match(new RegExp(teamsData[i].city, "i")) &&
         fullName.match(new RegExp(teamsData[i].team, "i")) )
    {
      return teamsData[i];
    }
  }
  return invalidTeam;
}

function GetTeamFromAbrv(abrv)
{
	var i;
  for (i = 0; i < 30; ++i)
  {
    if (teamsData[i].abrv.match(new RegExp(abrv, "i")))
    {
      return teamsData[i];
    }
  }
  return invalidTeam;
}

function UpdateTitle()
{
  var team = GetTeamFromFullName(options.GetValue("team_choice"));
  view.caption = team.team;
}

/*
Options
-------
  team_choice (Montreal Canadiens)
*/
function SetDefaultOptions()
{
	BuildTeamsData();

  if (GetTeamFromFullName(options.GetValue("team_choice")) == invalidTeam)
  {
    options.PutValue("team_choice", "Montreal Canadiens");
  }

  options.PutValue("last_event", "0");
  options.PutValue("last_url", "");

  if (options.GetValue("show_shots") != "1" &&
      options.GetValue("show_shots") != "0")
  {
    options.PutValue("show_shots", "1");
  }
  if (options.GetValue("alert_goal") != "1" &&
      options.GetValue("alert_goal") != "0")
  {
    options.PutValue("alert_goal", "1");
  }
  if (options.GetValue("alert_penalty") != "1" &&
      options.GetValue("alert_penalty") != "0")
  {
    options.PutValue("alert_penalty", "1");
  }

  UpdateTitle();

  pluginHelper.RemoveAllContentItems();
  AddLine("Updating...");
}

function UpdateToPreviousDay()
{
	if (iDayDiff < 7)
	{
    iDayDiff++;
    SearchWeek();
  }
  else
  {
    // We found no game for this team in the last 7 days.
    pluginHelper.RemoveAllContentItems();
    AddLine("No game found.", scoresUrl);
  }
}

function SearchGamesOnLink(link)
{
  var http = new XMLHttpRequest();
  http.onreadystatechange = ScoresReady;
  http.open("POST", link, true);
  http.setRequestHeader( "If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT" );
  http.send();

  function ScoresReady()
  {
    if (http.readyState == 4 && http.status == 200)
    {
      var response = http.responseText;
      http = null;

      response = response.replace(/\n/g, "");
      response = response.replace(/\r/g, "");

      var pbpLinks = response.match(/http:\/\/www.nhl.com\/scores\/htmlreports\/[^\/]*\/PL[\d]*.HTM/ig);

      if (pbpLinks)
      {
      	nbActiveSearches = pbpLinks.length;
      	bFoundValidSite = false;
      	toAddLines = new Array(0);

        var i;
        for (i = 0; i < pbpLinks.length; ++i)
        {
          var tmpItem = new FillToolbar(pbpLinks[i]);
          tmpItem = null;
        }
      }
      else
      {
      	UpdateToPreviousDay();
      }
    }
  }
}

function OnTimer()
{
	BuildTeamsData();

  iDayDiff = 0;

  SearchWeek();
}

function FormatDate(date)
{
  return ((date.getMonth() + 1).toString() + "/" +
           date.getDate().toString() + "/" +
           date.getFullYear().toString());
}

function SearchWeek()
{
  var baseUrl = "http://www2.nhl.com/nhl/app?date=";

  var useDate = new Date();
  useDate.setDate(useDate.getDate() - iDayDiff);

  scoresUrl = baseUrl + FormatDate(useDate) + "&page=Scoreboard&service=page";

  SearchGamesOnLink(scoresUrl);
}

function TrimString(str)
{
  if (str == undefined) return str;
  str = str.replace( /^\s+/g, "" );   // strip leading whitespaces
  return str.replace( /\s+$/g, "" );  // strip trailing whitespaces
}

//---- Functions to manage the options dialog
function ShowOptionsDlg(wnd)
{
  BuildTeamsData();

  wnd.AddControl(gddWndCtrlClassLabel, 0, "", strOptionsDlgLabel1Text, 10, 10, 380, 25);
  var list = wnd.AddControl(gddWndCtrlClassList, gddWndCtrlTypeListDrop, "team_choice", fullTeamNames, 10, 35, 300, 25);
  var curChoice = options.GetValue("team_choice");
  if (curChoice != "")
  {
    list.value = curChoice;
  }

  wnd.AddControl(gddWndCtrlClassLabel, 0, "", strOptionsDlgLabel2Text, 10, 70, 380, 25);
  wnd.AddControl(gddWndCtrlClassLabel, 0, "", strOptionsDlgLabel3Text, 10, 120, 380, 25);
  var chk_shots = wnd.AddControl(gddWndCtrlClassButton, gddWndCtrlTypeButtonCheck, "chk_shots", strOptionsShots, 10, 85, 300, 25);
  var chk_alert_goal = wnd.AddControl(gddWndCtrlClassButton, gddWndCtrlTypeButtonCheck, "chk_alert_goal", strOptionsGoalAlert, 10, 135, 300, 25);
  var chk_alert_pen = wnd.AddControl(gddWndCtrlClassButton, gddWndCtrlTypeButtonCheck, "chk_alert_pen", strOptionsPenaltyAlert, 10, 155, 300, 25);
  if (options.GetValue("show_shots") == "1")
  {
    chk_shots.value = "True";
  }
  if (options.GetValue("alert_goal") == "1")
  {
    chk_alert_goal.value = "True";
  }
  if (options.GetValue("alert_penalty") == "1")
  {
    chk_alert_pen.value = "True";
  }

  // handlers
  wnd.onClose = OptionsDlgClosed;
}

function UpdateCheckOption(wnd, control, option)
{
	if (wnd.GetControl(control).value)
	{
    options.PutValue(option, "1");
  }
  else
  {
    options.PutValue(option, "0");
  }
}

function OptionsDlgClosed(wnd, code)
{
  if (code == gddIdOK)
  {
    var team_choice = wnd.GetControl("team_choice");
    options.PutValue("team_choice", team_choice.value);
    options.PutValue("last_url", "");
    UpdateCheckOption(wnd, "chk_shots", "show_shots");
    UpdateCheckOption(wnd, "chk_alert_goal", "alert_goal");
    UpdateCheckOption(wnd, "chk_alert_pen", "alert_penalty");

    UpdateTitle();

    pluginHelper.RemoveAllContentItems();
    AddLine("Updating...");

    setTimeout("OnTimer()", 100);
  }
}

function AddLine(line, url)
{
  var newItem = new ContentItem();
  newItem.layout = gddContentItemLayoutNowrapItems;
  newItem.heading = line;
  if (url)
  {
    newItem.open_command = url;
  }
  newItem.flags = gddContentItemFlagNoRemove;
  pluginHelper.AddContentItem(newItem, gddItemDisplayInSidebar);
}

function FormatCase(str)
{
	if (str == undefined) return str;
    var words = str.split(" ");
    var i;
    for (i = 0; i < words.length; ++i)
    {
        words[i] = words[i].substring(0, 1).toUpperCase() +
                   words[i].substring(1, words[i].length).toLowerCase();
    }
    return words.join(" ");
}

// Class for events
function RTSSEvent(period, mins, secs, event, team, desc)
{
    this.period = period;
    this.mins = mins;
    this.secs = secs;
    this.event = event;
    this.team = team;
    this.desc = desc;
}

function ShowEvent(event, url)
{
  var newItem = new ContentItem();
  var team = GetTeamFromAbrv(event.team);
  newItem.heading = event.event + " (" + team.team + ")";
  newItem.snippet = event.desc;
  pluginHelper.AddContentItem(newItem, gddItemDisplayInSidebar + gddItemDisplayAsNotification);
  pluginHelper.RemoveContentItem(newItem);
}

function FillToolbar(url, http)
{
  // send request to webserver for data
  var http = new XMLHttpRequest();
  http.onreadystatechange = RequestReady;
  http.open("POST", url, true);
  http.setRequestHeader( "If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT" );
  http.send();

  function RequestReady()
  {
    if (http.readyState == 4 && http.status == 200)
    {
      var response = http.responseText;

      var lines = response.split("\n");
      response = response.replace(/\n/g, "");
      response = response.replace(/\r/g, "");

      teamData = response.match(/<img src[^>]+><br><br>([^>]*)<br>(.*?)<img src[^>]+><br><br>([^>]*)<br>/i);

      if (teamData)
      {
        var visitorShots = 0;
        var homeShots = 0;

        var visitorTeam = GetTeamFromFullName(FormatCase(TrimString(teamData[1])));
        var homeTeam = GetTeamFromFullName(FormatCase(TrimString(teamData[3])));
        var teamChoice = GetTeamFromFullName(options.GetValue("team_choice"));
        if ( !bFoundValidSite &&
             ((visitorTeam.city == teamChoice.city && visitorTeam.team == teamChoice.team) ||
             (homeTeam.city == teamChoice.city    && homeTeam.team == teamChoice.team)) )
        {
        	bFoundValidSite = true;
        	validUrl = url;

          var visitorScore = 0;
          var homeScore = 0;

          scoreData = response.match(/<font size=[^>]*7[^>]*>(\d+)(.*?)<font size=[^>]*7[^>]*>(\d+)/i);
          if (scoreData)
          {
            visitorScore = scoreData[1];
            homeScore = scoreData[3];
          }

          var MAX_EVENTS = 1000;
          var eventArray = new Array(MAX_EVENTS);
          var lastArrayEvent = 0;
  
          var stateString = "";
          var startString = "";
          var bPreGame = false;
          var bFinal = false;
          var bBegin = false;
          var i;
          for (i = 0; i < lines.length; ++i)
          {
            var line = lines[i];

            // Verify when the game starts
            var stringData = line.match(/(^\s*(Start|Debut)[^<]*)<br>\s*$/i);
            if (stringData)
            {
              startString = stringData[1];
              startString = startString.replace(/Debut/i, "Start");

              // Try to get period/time remaining
              stringData = lines[i+1].match(/^\s*([^<]*)<br>\s*$/i);
              if (stringData)
              {
                stateString = stringData[1];
                stateString = stateString.replace(/per\./i, "Period");
                stateString = stateString.replace(/Period 4/i, "Overtime");
                stateString = stateString.replace(/Period 5/i, "Shootout");
                stateString = stateString.replace(/(\d+:\d+)\s.*ouer/i, '$1' + " Remaining");
                stateString = stateString.replace(/Remaining/i, "Left");
                stateString = stateString.replace(/Avant-Match/i, "Pre-Game");
              }
            }
            if (line.match(/^\s*final<br>/i))
            {
              bFinal = true;
            }
            if (line.match(/^\s*pre-game<br>/i))
            {
              bPreGame = true;
            }
            if (line.match(/<pre>/i))
            {
              bBegin = true;
            }
            if (line.match(/<\/pre>/i))
            {
              break;
            }
  
            if (bBegin)
            {
              var eventData = line.match(/(\d+)\s*(\d+)\s*[0]*(\d+):[0]*(\d+)\s*(.+?)\s\s(\S\S\S)\s*(\S+)\s*([^<]+)/i);
              if (eventData)
              {
                var eventNumber = parseInt(eventData[1]);
              	var periodNumber = parseInt(eventData[2]);
              	var minutes = parseInt(eventData[3]);
              	var seconds = parseInt(eventData[4]);
              	var event = FormatCase(TrimString(eventData[5]));
              	var team = FormatCase(TrimString(eventData[6]));
              	var desc = FormatCase(TrimString(eventData[8]));
    
              	if (event.match(/^shot$/i) || event.match(/^goal$/i))
              	{
                  if (team.match(new RegExp(visitorTeam.abrv, "i")))
                  {
                    visitorShots++;
                  }
                  else if (team.match(new RegExp(homeTeam.abrv, "i")))
                  {
                    homeShots++;
                  }
                }

                eventArray[eventNumber-1] = new RTSSEvent(periodNumber, minutes, seconds, event, team, desc);

                lastArrayEvent = eventNumber;
              }
            }
          }

          var last_url = options.GetValue("last_url");
          if (url != last_url)
          {
            options.PutValue("last_event", lastArrayEvent.toString());
          }
          options.PutValue("last_url", url);

          var lastEventNumber = parseInt(options.GetValue("last_event"));

          for (i = lastEventNumber; i < lastArrayEvent; i++)
          {
            if (eventArray[i].event.match(/^goal$/i))
            {
            	if (options.GetValue("alert_goal") == "1")
            	{
            	  ShowEvent(eventArray[i], url);
              }
            }
            else if (eventArray[i].event.match(/penalty/i))
            {
            	if (options.GetValue("alert_penalty") == "1")
            	{
              	ShowEvent(eventArray[i], url);
              }
            }
          }
  
          var lastEventData = eventArray[lastArrayEvent-1];
          if (bFinal)
          {
          	toAddLines.push("Final scores");
          }
          else if (bPreGame)
          {
          	toAddLines.push(startString);
          	toAddLines.push(stateString);
          }
          else
          {
          	toAddLines.push(stateString);
          }
          if (options.GetValue("show_shots") == "1")
          {
          	toAddLines.push(visitorTeam.team + " : " + visitorScore + " (S : " + visitorShots + ")");
          	toAddLines.push(homeTeam.team + " : " + homeScore + " (S : " + homeShots + ")");
          }
          else
          {
          	toAddLines.push(visitorTeam.team + " : " + visitorScore);
            toAddLines.push(homeTeam.team + " : " + homeScore);
          }
  
          options.PutValue("last_event", lastArrayEvent.toString());
        }
      }

      // This is always done, even if the page is not for our team.

      http = null;  // free the http object

      // Seems to be safe after doing some tests...
      nbActiveSearches = nbActiveSearches - 1;
      if (nbActiveSearches == 0)
      {
        if (!bFoundValidSite)
        {
        	UpdateToPreviousDay();
        }
        else
        {
          pluginHelper.RemoveAllContentItems();

        	var i;
        	for (i = 0; i < toAddLines.length; ++i)
        	{
            AddLine(toAddLines[i], validUrl);
          }
          if (iDayDiff == 1)
          {
            AddLine("- Yesterday - ");
          }
          else if (iDayDiff > 1)
          {
            AddLine("- " + iDayDiff + " days ago - ");
          }
        }
      }
    }
  }
}

